//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "stdio.h"
#include "IniFiles.hpp"

//---------------------------------------------------------------------------

#define FILENAME_OUT  "wav.bin"


long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;

}


#pragma argsused
int main(int argc, char* argv[])
{
   TIniFile *ini;
   AnsiString asWav1, asWav2;
   FILE *f_in1, *f_in2, *f_out;
   unsigned int numberOfFiles = 0;
   unsigned int len, i;
   unsigned char dat;
   #define WAV_HEADERSIZE 44


   ini = new TIniFile( ".\\setup.ini" );
   asWav1 = ini->ReadString("wavfiles", "file1", "");
   if(asWav1 == "")
   {
      ini->WriteString("wavfiles", "file1", "");
      asWav2 = ini->ReadString("wavfiles", "file2", "");
      if(asWav2 == "")
      {
         ini->WriteString("wavfiles", "file2", "");
      }
      printf("Error: Please check content in setup.ini file\n\r");
      return 1;
   }
   else
   {
      f_out = fopen(".\\" FILENAME_OUT, "wb");
      if(f_out)
      {
      }
      else
      {
         printf("Error when opening file %s.\n\r", FILENAME_OUT);
         return 2;
      }

      f_in1 = fopen(asWav1.c_str(), "rb");
      if(f_in1)
      {
      }
      else
      {
         printf("Error when opening file %s.\n\r", asWav1);
         return 3;
      }
      numberOfFiles++;

      asWav2 = ini->ReadString("wavfiles", "file2", "");
      if(asWav2 == "")
      {
         ini->WriteString("wavfiles", "file2", "");
      }
      else
      {
         f_in2 = fopen(asWav2.c_str(), "rb");
         if(f_in2)
         {
         }
         else
         {
            printf("Error when opening file %s.\n\r", asWav2);
            return 4;
         }
         numberOfFiles++;
      }

      fprintf(f_out, "%c", numberOfFiles);

      len = filesize(f_in1);
      if(len > WAV_HEADERSIZE)
      {
         len -= WAV_HEADERSIZE;
      }
      else
      {
         len = 0;
      }
      fprintf(f_out, "%c%c", len >> 8, len & 0xFF);

      if(numberOfFiles >= 2)
      {
         len = filesize(f_in2);
         if(len > WAV_HEADERSIZE)
         {
            len -= WAV_HEADERSIZE;
         }
         else
         {
            len = 0;
         }
         fprintf(f_out, "%c%c", len >> 8, len & 0xFF);
      }

      i = 0;
      len = filesize(f_in1);
      while(i < len)
      {
         fread(&dat, 1, 1, f_in1);
         if(i >= 44)
         {
            fprintf(f_out, "%c", dat);
         }
         i++;
      }

      if(numberOfFiles >= 2)
      {
         i = 0;
         len = filesize(f_in2);
         while(i < len)
         {
            fread(&dat, 1, 1, f_in2);
            if(i >= 44)
            {
               fprintf(f_out, "%c", dat);
            }
            i++;
         }
      }

      fclose(f_out);
      fclose(f_in1);
      if(numberOfFiles >= 2)
      {
         fclose(f_in2);
      }
   }
   delete ini;
   printf("Done. Written to file %s.\n\r", FILENAME_OUT);

   return 0;
}
//---------------------------------------------------------------------------
  
